unit Unit1; 

{$mode Delphi}{$H+}

interface

uses
  Classes, SysUtils, LResources, Forms, Controls, Graphics, Dialogs, StdCtrls,
  ExtCtrls, Menus, optels;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    ColorDialog1: TColorDialog;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    LabeledEdit1: TLabeledEdit;
    Kind1: TMenuItem;
    flMirror1: TMenuItem;
    Left2: TMenuItem;
    Left1: TMenuItem;
    Right1: TMenuItem;
    Right2: TMenuItem;
    pMirror1: TMenuItem;
    nMirror1: TMenuItem;
    nLens1: TMenuItem;
    pLens1: TMenuItem;
    Panel1: TPanel;
    Panel2: TPanel;
    Panel3: TPanel;
    Panel4: TPanel;
    PopupMenu1: TPopupMenu;
    RadioButton1: TRadioButton;
    RadioButton10: TRadioButton;
    RadioButton11: TRadioButton;
    RadioButton2: TRadioButton;
    RadioButton3: TRadioButton;
    RadioButton5: TRadioButton;
    RadioButton6: TRadioButton;
    RadioButton7: TRadioButton;
    RadioButton8: TRadioButton;
    RadioButton9: TRadioButton;
    ScrollBar1: TScrollBar;
    ScrollBar2: TScrollBar;
    procedure FormClose(Sender: TObject; var CloseAction: TCloseAction);
    procedure OptEls1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure pLens1Click(Sender: TObject);
    procedure ScrollBar1Change(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure RadioButton1Click(Sender: TObject);
    procedure RadioButton5Click(Sender: TObject);
    procedure LabeledEdit1Change(Sender: TObject);
    procedure ScrollBar2Change(Sender: TObject);
    procedure PopupMenu1Popup(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end; 

var
  Form1: TForm1; 
  OptEls1: TOptEls;  // Component TOptEls
  
implementation

{ TForm1 }

var
  Slide: Word;

procedure TForm1.OptEls1Click(Sender: TObject);
begin
inc(Slide);
With OptEls1 do begin
Case Slide of
1: Kind:=nLens;
2: Kind:=flMirror;
3: Kind:=pMirrorL;
4: Kind:=pMirrorR;
5: Kind:=nMirrorR;
6: Kind:=nMirrorL;
7: Kind:=pLens;
8: Slide:=0;
end;
                end;
If OptEls1.Kind = flMirror
then Form1.ScrollBar1.Enabled:=False
else Form1.ScrollBar1.Enabled:=True;
end;

procedure TForm1.FormClose(Sender: TObject; var CloseAction: TCloseAction);
begin
  OptEls1.Free;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
OptEls1:=TOptEls.Create(Self);
OptEls1.OnClick:= OptEls1Click;
With OptEls1 do
begin
  Parent:=Panel4;
  Width:=Panel4.Width-4;
  Height:=Panel4.Height-4;
  Top:=2;
  Left:=2;
  PopUpMenu:= PopupMenu1;
  Caption:= '';
end;
Slide:=0;
ScrollBar1.Position:=OptEls1.CurvFromWidth;
ScrollBar2.Max:=OptEls1.Width;
ScrollBar2.Position:=OptEls1.Width;
end;

procedure TForm1.pLens1Click(Sender: TObject);
begin  // selecting of element kind from menu
with OptEls1 do
Case (Sender as TMenuItem).Tag of
1 : Kind:=pLens;
2 : Kind:=nLens;
3 : Kind:=flMirror;
4 : Kind:=nMirrorR;
5 : Kind:=nMirrorL;
6 : Kind:=pMirrorR;
7 : Kind:=pMirrorL;
end;
If OptEls1.Kind = flMirror
then ScrollBar1.Enabled:=False
else ScrollBar1.Enabled:=True;
end;

procedure TForm1.ScrollBar1Change(Sender: TObject);
begin
OptEls1.CurvFromWidth:=ScrollBar1.Position;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
If ColorDialog1.Execute then
OptEls1.BodyColor:=ColorDialog1.Color;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
If ColorDialog1.Execute then
OptEls1.ContourColor:=ColorDialog1.Color;
end;

procedure TForm1.RadioButton1Click(Sender: TObject);
begin
With (Sender as TRadioButton) do begin
IF Sender = RadioButton1
then OptEls1.ContourStyle:=psSolid;
IF Sender = RadioButton2
then OptEls1.ContourStyle:=psDash;
IF Sender = RadioButton3
then OptEls1.ContourStyle:=psDot;
end;
end;

procedure TForm1.RadioButton5Click(Sender: TObject);
begin
With (Sender as TRadioButton) do begin
IF Sender = RadioButton5
then OptEls1.BodyStyle:=bsSolid;
IF Sender = RadioButton6
then OptEls1.BodyStyle:=bsBDiagonal;
IF Sender = RadioButton7
then OptEls1.BodyStyle:=bsFDiagonal;
IF Sender = RadioButton8
then OptEls1.BodyStyle:=bsHorizontal;
IF Sender = RadioButton9
then OptEls1.BodyStyle:=bsVertical;
IF Sender = RadioButton10
then OptEls1.BodyStyle:=bsCross;
IF Sender = RadioButton11
then OptEls1.BodyStyle:=bsDiagCross;
end;
end;

procedure TForm1.LabeledEdit1Change(Sender: TObject);
begin
IF LabeledEdit1.Text = '' then begin {do nothing} end
else
begin
        try StrToInt(LabeledEdit1.Text);
        except begin ShowMessage('Must be integer value');
        LabeledEdit1.Text:=''; exit;end;
end;
OptEls1.ContourWidth:= StrToInt(LabeledEdit1.Text);
IF OptEls1.ContourWidth > 1 then begin
Form1.RadioButton2.Enabled:=False; Form1.RadioButton3.Enabled:=False;
Form1.RadioButton1.Checked:=True; end
else begin
Form1.RadioButton2.Enabled:=True; Form1.RadioButton3.Enabled:=True; end;
end;
end;

procedure TForm1.ScrollBar2Change(Sender: TObject);
begin
OptEls1.Width:=ScrollBar2.Position;
end;

procedure TForm1.PopupMenu1Popup(Sender: TObject);
begin
With OptEls1 do begin
If Kind = plens then pLens1.Checked:=True else pLens1.Checked:=False;
If Kind = nlens then nLens1.Checked:=True else nLens1.Checked:=False;
If Kind = flMirror then flMirror1.Checked:=True else flMirror1.Checked:=False;
If Kind = nMirrorR then Right2.Checked:=True else Right2.Checked:=False;
If Kind = nMirrorL then Left2.Checked:=True else Left2.Checked:=False;
If Kind = pMirrorR then Right1.Checked:=True else Right1.Checked:=False;
If Kind = pMirrorL then Left1.Checked:=True else Left1.Checked:=False;

IF Right2.Checked or Left2.Checked then nMirror1.Checked:=True
else nMirror1.Checked:=False;

IF Right1.Checked or Left1.Checked then pMirror1.Checked:=True
else pMirror1.Checked:=False;

end;
end;

initialization
  {$I unit1.lrs}

end.

